package sudoku.bThreads;

import static bp.BProgram.labelNextVerificationState;
import static bp.eventSets.EventSetConstants.none;
import static sudoku.externalApp.Sudoku.suLog;

import java.util.HashSet;
import java.util.Set;

import sudoku.events.Competitors;
import sudoku.events.Move;
import bp.BProgram;
import bp.BThread;
import bp.exceptions.BPJException;

/**
 * A scenario that tries to write a number in a square 
 * and when succeeds it blocks all other options.  
 * Its requested event may be unified with strategies - and it then provides the blocking
 */
public class DefaultMove extends BThread {

	private Move move;
	private Competitors competitors;

	public void runBThread() throws BPJException {
		// interruptingEvents = new EventSet(gameOver);

		labelNextVerificationState("0");

		BProgram.bp.bSync(move, none, none);
		suLog("by " + this); 
		
		labelNextVerificationState("1");
		BProgram.bp.bSync(none, none, competitors);

	}

	public DefaultMove(Move move) {
		super();
		this.move = move;
		this.competitors = new Competitors(move); 

		this.setName("MakeOneMove(" + move + ")");
	}

	/**
	 * Construct all instances
	 */

	static public Set<BThread> constructInstances() {

		Set<BThread> set = new HashSet<BThread>();

		for (int row = 0; row < 9; row++) {
			for (int col = 0; col < 9; col++) {
				for (int number = 1; number <= 9; number++)
					set.add(new DefaultMove(new Move(row, col, number)));
			}
		}
		return set;

	}

}